apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: mysql
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: {{ percona_name }}
    backups.opsperator.io/service: {{ percona_name }}-client
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ percona_name }}
  name: {{ percona_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ percona_replicas }}
  selector:
    matchLabels:
      name: {{ percona_name }}
  serviceName: {{ percona_name }}
  template:
    metadata:
      labels:
        name: {{ percona_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ percona_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ percona_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
{% if (mysql_options | default([])) | length > 0 %}
      - args:
        - mysqld
{% for opt in mysql_options %}
        - {{ opt }}
{% endfor %}
        env:
{% else %}
      - env:
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: MYSQL_DATABASE
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-name
        - name: MYSQL_MONITOR_PASSWORD
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-monitor-password
        - name: MYSQL_MONITOR_USER
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-monitor-user
        - name: MYSQL_PASSWORD
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-password
        - name: MYSQL_REPL_PASSWORD
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-repl-password
        - name: MYSQL_REPL_USER
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-repl-user
        - name: MYSQL_ROOT_PASSWORD
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-admin-password
        - name: MYSQL_USER
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-user
        - name: PERCONA_HOSTNAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: PERCONA_STATEFULSET_NAME
          value: {{ percona_name }}
        - name: POD_NAMESPACE
          valueFrom:
            fieldRef:
              fieldPath: metadata.namespace
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='percona'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 3306
          timeoutSeconds: 3
        name: percona
        ports:
        - containerPort: 3306
          name: mysql
        - containerPort: 4444
          name: sst
        - containerPort: 4567
          name: galera
        - containerPort: 4568
          name: ist
        readinessProbe:
          exec:
            command:
            - /clustercheck.sh
          initialDelaySeconds: 5
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
          requests:
            cpu: "{{ cpu_limit }}"
            memory: "{{ memory_limit }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 3306
          timeoutSeconds: 5
{% endif %}
        volumeMounts:
        - mountPath: /var/lib/mysql
          name: data
          subPath: db
        - mountPath: /etc/mysql/conf.d
          name: data
          subPath: config
{% if do_exporters %}
      - args:
        - --collect.auto_increment.columns
        - --collect.binlog_size
        - --collect.engine_innodb_status
        - --collect.global_status
        - --collect.global_variables
        - --collect.info_schema.processlist
        - --collect.info_schema.userstats
        - --collect.info_schema.innodb_cmp
        - --collect.info_schema.innodb_cmpmem
        - --collect.info_schema.innodb_metrics
        - --collect.info_schema.innodb_tablespaces
        - --collect.info_schema.query_response_time
        - --collect.info_schema.tables
        - --collect.info_schema.tables.databases=*
        - --collect.info_schema.tablestats
        - --collect.perf_schema.eventsstatements
        - --collect.perf_schema.eventsstatementssum
        - --collect.perf_schema.eventswaits
        - --collect.perf_schema.file_events
        - --collect.perf_schema.file_instances
        - --collect.perf_schema.indexiowaits
        - --collect.perf_schema.tableiowaits
        - --collect.perf_schema.tablelocks
        - --collect.perf_schema.replication_group_members
        - --collect.perf_schema.replication_group_member_stats
        - --collect.slave_status
        env:
        - name: DATA_SOURCE_HOST
          value: 127.0.0.1
        - name: DATA_SOURCE_PASS
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-monitor-password
        - name: DATA_SOURCE_USER
          valueFrom:
            secretKeyRef:
              name: {{ percona_name }}
              key: database-monitor-user
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        image: {{ (opsimages | json_query("[?name=='mysqlexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 9113
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-database
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
      terminationGracePeriodSeconds: {{ percona_termination_timeout | default(600) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ percona_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ percona_data_volume_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
